class GameOverSceneBehavior extends Sup.Behavior {
	private selection: number = 0;

	awake() {
		this.actor.spriteRenderer.setAnimation("Appear");
		this.actor.spriteRenderer.playAnimation(false);
	}

	update() {
		// Don't do anything as long as the appear animation isn't finished
		if (this.actor.spriteRenderer.getAnimation() == "Appear" && this.actor.spriteRenderer.isAnimationPlaying()) {
			return;
		}
		
		// Manage the menu selection on the vertical axis
		if ((Sup.Input.wasKeyJustReleased("UP") || Sup.Input.wasKeyJustReleased("Z") || Sup.Input.wasKeyJustReleased("W")) && this.selection > 0) {
			this.selection--;
		} else if ((Sup.Input.wasKeyJustReleased("DOWN") || Sup.Input.wasKeyJustReleased("S")) && this.selection < 1) {
			this.selection++;
		}
		
		// Draw the menu
		if (this.selection == 0) {
			this.actor.spriteRenderer.setAnimation("Recommencer");
		} else {
			this.actor.spriteRenderer.setAnimation("Quitter");
		}
		
		// Do the action
		if (Sup.Input.wasKeyJustReleased("RETURN") || Sup.Input.wasKeyJustReleased("SPACE")) {
			switch (this.selection) {
				case 0:
					g_gender = (g_gender == "Boy") ? "Girl" : "Boy";
					Sup.loadScene("Scenes/Scene_Game");
					break;
				case 1:
					Sup.loadScene("Scenes/Scene_Title");
					break;
			}
		}
		
		// Go back to title on escape
		if (Sup.Input.wasKeyJustReleased("ESCAPE")) {
			Sup.loadScene("Scenes/Scene_Title");
		}
	}
}
Sup.registerBehavior(GameOverSceneBehavior);
