class IntroSceneBehavior extends Sup.Behavior {
	
	private redirection: number = null;
	
	awake() {
		// Set the sprite depending on the player gender
		this.actor.spriteRenderer.setAnimation(g_gender, false);
		
		// Redirect to the game after 5 seconds
		this.redirection = Sup.setTimeout(5000, () => {
			g_bgm.stop();
			g_bgm = null;
			Sup.loadScene("Scenes/Scene_Game");
		});
		
		// Play the voice
		Sup.Audio.playSound("Sounds/Sound_Intro_" + g_gender, g_volume_sfx);
		
		// Play the keyboard noise
		g_bgm = Sup.Audio.playSound("Sounds/Sound_Clavier", g_volume_bgm, {loop: true});
		g_bgm.play();
	}

	update() {
		// Go to game on any keyboard key press
		if (Sup.Input.wasKeyJustReleased("ANY")) {
			g_bgm.stop();
			g_bgm = null;
			Sup.clearInterval(this.redirection);
			Sup.loadScene("Scenes/Scene_Game");
		}
	}
}
Sup.registerBehavior(IntroSceneBehavior);
