class OptionsSceneBehavior extends Sup.Behavior {
	private selection: number = 0;

	awake() {
		
	}

	update() {
		// Manage the menu selection on the vertical axis
		if ((Sup.Input.wasKeyJustReleased("UP") || Sup.Input.wasKeyJustReleased("Z") || Sup.Input.wasKeyJustReleased("W")) && this.selection > 0) {
			this.selection--;
		} else if ((Sup.Input.wasKeyJustReleased("DOWN") || Sup.Input.wasKeyJustReleased("S")) && this.selection < 2) {
			this.selection++;
		}
		
		// Manage the change of the options
		if (Sup.Input.wasKeyJustReleased("LEFT") || Sup.Input.wasKeyJustReleased("Q") || Sup.Input.wasKeyJustReleased("A")) {
			if (this.selection == 0 && g_volume_bgm > 0.1) {
				g_volume_bgm -= 0.10;
			} else if (this.selection == 1 && g_volume_sfx > 0.1) {
				g_volume_sfx -= 0.10;
			}
		} else if (Sup.Input.wasKeyJustReleased("RIGHT") || Sup.Input.wasKeyJustReleased("D")) {
			if (this.selection == 0 && g_volume_bgm < 0.9) {
				g_volume_bgm += 0.10;
			} else if (this.selection == 1 && g_volume_sfx < 0.9) {
				g_volume_sfx += 0.10;
			}
		}
		
		// Go back to title
		if (Sup.Input.wasKeyJustReleased("ESCAPE") ||
			((Sup.Input.wasKeyJustReleased("RETURN") || Sup.Input.wasKeyJustReleased("SPACE")) && this.selection == 2)) {
			Sup.loadScene("Scenes/Scene_Title");
		}
		
		// Set the position of the selector
		this.actor.setY(0.771 - (this.selection * 2.6));
		
		// Fill the options with their value
		Sup.getActor("BGM_Value").textRenderer.setText(Math.round(g_volume_bgm * 10));
		Sup.getActor("SFX_Value").textRenderer.setText(Math.round(g_volume_sfx * 10));
	}
}
Sup.registerBehavior(OptionsSceneBehavior);
