class PatronBehavior extends Sup.Behavior {
	
	private seenPlayer: boolean = false;
	
	awake() {
		this.actor.spriteRenderer.setAnimation("Idle").playAnimation(true);
	}

	update() {
		// Detect if the player collides the director
		if (Sup.ArcadePhysics2D.intersects(this.actor.arcadeBody2D, g_player.actor.arcadeBody2D) && !this.seenPlayer) {
			this.seenPlayer = true;
			g_blockPlayerMove = true;
			
			// Play the voice
			Sup.Audio.playSound("Sounds/Sound_Patron", g_volume_sfx);
			
			// Set the animation
			this.actor.spriteRenderer.setAnimation("Talking").playAnimation(true);
			this.actor.getChild("BlaBla").setVisible(true);
			
			Sup.setTimeout(5000, () => {
				this.actor.spriteRenderer.setAnimation("Idle").playAnimation(true);
				this.actor.getChild("BlaBla").setVisible(false);
				g_blockPlayerMove = false;
			});
		}
	}
}
Sup.registerBehavior(PatronBehavior);
