class RoomBehavior extends Sup.Behavior {
	
	private showing: boolean = false;
	
	awake() {
		// Always hide the room at first
		this.actor.spriteRenderer.setOpacity(1);
	}

	update() {
		// Start the fade animation if the player enters the room
		if (Sup.ArcadePhysics2D.intersects(g_player.actor.arcadeBody2D, this.actor.arcadeBody2D)) {
			this.showing = true;
			g_currentRoom = this.actor;
		}
		
		let opacity = this.actor.spriteRenderer.getOpacity();
		
		// Apply the new opacity and hide at end
		if (this.showing) {
			if (opacity > 0) {
				this.actor.spriteRenderer.setOpacity(opacity - 0.10);
			} else {
				this.actor.setVisible(false);
				this.showing = false;
			}
		}
	}
}
Sup.registerBehavior(RoomBehavior);
