class TitleSceneBehavior extends Sup.Behavior {
	private selection: string = "Play";
	
    awake() {
		// Play the title sound
		if (g_titleVoice) {
			g_titleVoice = false;
			Sup.Audio.playSound("Sounds/Sound_Title", g_volume_sfx);
		}
    }

    update() {
		// Manage the menu selection on the vertical axis
		if ((Sup.Input.wasKeyJustReleased("UP") || Sup.Input.wasKeyJustReleased("Z") || Sup.Input.wasKeyJustReleased("W")) && this.selection == "Credits") {
			this.selection = "Play";
		} else if (Sup.Input.wasKeyJustReleased("DOWN") || Sup.Input.wasKeyJustReleased("S")) {
			this.selection = "Credits";
		}
		
		// Manage the menu selection on the horizontal axis
		if (Sup.Input.wasKeyJustReleased("LEFT") || Sup.Input.wasKeyJustReleased("Q") || Sup.Input.wasKeyJustReleased("A")) {
			if (this.selection == "Quit") {
				this.selection = "Play";
			} else if (this.selection == "Play" || this.selection == "Credits") {
				this.selection = "Options";
			}
		} else if (Sup.Input.wasKeyJustReleased("RIGHT") || Sup.Input.wasKeyJustReleased("D")) {
			if (this.selection == "Options") {
				this.selection = "Play";
			} else if (this.selection == "Play" || this.selection == "Credits") {
				this.selection = "Quit";
			}
		}
		
		// When selecting a menu item
		if (Sup.Input.wasKeyJustReleased("RETURN") || Sup.Input.wasKeyJustReleased("SPACE")) {
			switch (this.selection) {
				case "Play":
					g_gender = (g_gender == "Boy") ? "Girl" : "Boy";
					Sup.loadScene("Scenes/Scene_Intro");
					break;
				case "Options":
					Sup.loadScene("Scenes/Scene_Options");
					break;
				case "Credits":
					Sup.loadScene("Scenes/Scene_Credits");
					break;
				case "Quit":
					Sup.exit();
					break;
			}
		}
		
		// Quit the game on escape
		if (Sup.Input.wasKeyJustReleased("ESCAPE")) {
			Sup.exit();
		}
		
		// Set the menu image
		this.actor.spriteRenderer.setAnimation(this.selection);
    }
}
Sup.registerBehavior(TitleSceneBehavior);
