class WinSceneBehavior extends Sup.Behavior {
	private selection: number = 0;

	awake() {
		Sup.getActor("PlayerBest").spriteRenderer.setSprite("Sprites/Player/Sprite_" + g_gender + "_Best");	
	}

	update() {
		// Manage the menu selection on the vertical axis
		if ((Sup.Input.wasKeyJustReleased("UP") || Sup.Input.wasKeyJustReleased("Z") || Sup.Input.wasKeyJustReleased("W")) && this.selection > 0) {
			this.selection--;
		} else if ((Sup.Input.wasKeyJustReleased("DOWN") || Sup.Input.wasKeyJustReleased("S")) && this.selection < 1) {
			this.selection++;
		}
		
		// Do the action
		if (Sup.Input.wasKeyJustReleased("RETURN") || Sup.Input.wasKeyJustReleased("SPACE")) {
			switch (this.selection) {
				case 0:
					g_gender = (g_gender == "Boy") ? "Girl" : "Boy";
					Sup.loadScene("Scenes/Scene_Game");
					break;
				case 1:
					Sup.loadScene("Scenes/Scene_Title");
					break;
			}
		}
		
		// Go back to title on escape
		if (Sup.Input.wasKeyJustReleased("ESCAPE")) {
			Sup.loadScene("Scenes/Scene_Title");
		}
		
		// Set the position of the selector
		this.actor.setY(-2.793 - (this.selection * 2.6)); // 0.771
	}
}
Sup.registerBehavior(WinSceneBehavior);
